# Class AssertionError

java.lang.Object
java.lang.Throwable
java.lang.Error
java.lang.AssertionError

All Implemented Interfaces:
  `Serializable`

public class AssertionError extends Error
Thrown to indicate that an assertion has failed.

The seven one-argument public constructors provided by this class ensure that the assertion error returned by the invocation:

        new AssertionError(expression)

has as its detail message the string conversion of expression (as defined in section §5.1.11 of The Java Language Specification), regardless of the type of expression.

Since:
  1.4
See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`AssertionError()`
Constructs an AssertionError with no detail message.
`AssertionError(boolean detailMessage)`
Constructs an AssertionError with its detail message derived from the specified `boolean`, which is converted to a string as defined in section §5.1.11 of The Java Language Specification.
`AssertionError(char detailMessage)`
Constructs an AssertionError with its detail message derived from the specified `char`, which is converted to a string as defined in section §5.1.11 of The Java Language Specification.
`AssertionError(double detailMessage)`
Constructs an AssertionError with its detail message derived from the specified `double`, which is converted to a string as defined in section §5.1.11 of The Java Language Specification.
`AssertionError(float detailMessage)`
Constructs an AssertionError with its detail message derived from the specified `float`, which is converted to a string as defined in section §5.1.11 of The Java Language Specification.
`AssertionError(int detailMessage)`
Constructs an AssertionError with its detail message derived from the specified `int`, which is converted to a string as defined in section §5.1.11 of The Java Language Specification.
`AssertionError(long detailMessage)`
Constructs an AssertionError with its detail message derived from the specified `long`, which is converted to a string as defined in section §5.1.11 of The Java Language Specification.
`AssertionError(Object detailMessage)`
Constructs an AssertionError with its detail message derived from the specified object, which is converted to a string as defined in section §5.1.11 of The Java Language Specification.
`AssertionError(String message, Throwable cause)`
Constructs a new `AssertionError` with the specified detail message and cause.

## Method Summary

### Methods declared in class Throwable

`addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`
Modifier and Type
Method
Description
`final void`
`addSuppressed(Throwable exception)`
Appends the specified exception to the exceptions that were suppressed in order to deliver this exception.
`Throwable`
`fillInStackTrace()`
Fills in the execution stack trace.
`Throwable`
`getCause()`
Returns the cause of this throwable or `null` if the cause is nonexistent or unknown.
`String`
`getLocalizedMessage()`
Creates a localized description of this throwable.
`String`
`getMessage()`
Returns the detail message string of this throwable.
`StackTraceElement[]`
`getStackTrace()`
Provides programmatic access to the stack trace information printed by `Throwable.printStackTrace()`.
`final Throwable[]`
`getSuppressed()`
Returns an array containing all of the exceptions that were suppressed, typically by the `try`-with-resources statement, in order to deliver this exception.
`Throwable`
`initCause(Throwable cause)`
Initializes the cause of this throwable to the specified value.
`void`
`printStackTrace()`
Prints this throwable and its backtrace to the standard error stream.
`void`
`printStackTrace(PrintStream s)`
Prints this throwable and its backtrace to the specified print stream.
`void`
`printStackTrace(PrintWriter s)`
Prints this throwable and its backtrace to the specified print writer.
`void`
`setStackTrace(StackTraceElement[] stackTrace)`
Sets the stack trace elements that will be returned by `Throwable.getStackTrace()` and printed by `Throwable.printStackTrace()` and related methods.
`String`
`toString()`
Returns a short description of this throwable.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### AssertionError

public AssertionError()
Constructs an AssertionError with no detail message.

### AssertionError

public AssertionError(Object detailMessage)
Constructs an AssertionError with its detail message derived from the specified object, which is converted to a string as defined in section §5.1.11 of The Java Language Specification.

If the specified object is an instance of `Throwable`, it becomes the cause of the newly constructed assertion error.

Parameters:
  `detailMessage` - value to be used in constructing detail message
See Also:
  - `Throwable.getCause()`

### AssertionError

public AssertionError(boolean detailMessage)
Constructs an AssertionError with its detail message derived from the specified `boolean`, which is converted to a string as defined in section §5.1.11 of The Java Language Specification.

Parameters:
  `detailMessage` - value to be used in constructing detail message

### AssertionError

public AssertionError(char detailMessage)
Constructs an AssertionError with its detail message derived from the specified `char`, which is converted to a string as defined in section §5.1.11 of The Java Language Specification.

Parameters:
  `detailMessage` - value to be used in constructing detail message

### AssertionError

public AssertionError(int detailMessage)
Constructs an AssertionError with its detail message derived from the specified `int`, which is converted to a string as defined in section §5.1.11 of The Java Language Specification.

Parameters:
  `detailMessage` - value to be used in constructing detail message

### AssertionError

public AssertionError(long detailMessage)
Constructs an AssertionError with its detail message derived from the specified `long`, which is converted to a string as defined in section §5.1.11 of The Java Language Specification.

Parameters:
  `detailMessage` - value to be used in constructing detail message

### AssertionError

public AssertionError(float detailMessage)
Constructs an AssertionError with its detail message derived from the specified `float`, which is converted to a string as defined in section §5.1.11 of The Java Language Specification.

Parameters:
  `detailMessage` - value to be used in constructing detail message

### AssertionError

public AssertionError(double detailMessage)
Constructs an AssertionError with its detail message derived from the specified `double`, which is converted to a string as defined in section §5.1.11 of The Java Language Specification.

Parameters:
  `detailMessage` - value to be used in constructing detail message

### AssertionError

public AssertionError(String message, Throwable cause)
Constructs a new `AssertionError` with the specified detail message and cause.

Note that the detail message associated with `cause` is not automatically incorporated in this error's detail message.

Parameters:
  `message` - the detail message, may be `null`
  `cause` - the cause, may be `null`
Since:
  1.7